﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MVCGrid;
using System.Data.Entity;
using MVCGrid.Models;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using System.Collections;
using Syncfusion.XlsIO;
using System.Web.Script.Serialization;
using System.Reflection;
namespace MVCGrid.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        IEnumerable filteredData;
        public ActionResult GridFeatures()
        {
            var DataSource = new simpledbEntities1().Orders.ToList();
            ViewBag.datasource = DataSource;
            return View();
        }
        public ActionResult Update(Order value)
        {
            simpledbEntities1 context = new simpledbEntities1();
            Order table = context.Orders.Single(v => v.OrderID == value.OrderID);
            context.Entry(table).CurrentValues.SetValues(value);
            context.Entry(table).State = EntityState.Modified;
            context.SaveChanges();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Insert(Order value)
        {
            simpledbEntities1 context = new simpledbEntities1();
            context.Orders.Add(value);
            context.SaveChanges();
            var data = context.Orders.ToList();
            return Json(value, JsonRequestBehavior.AllowGet);

        }

        public ActionResult Delete(int key)
        {
            simpledbEntities1 context = new simpledbEntities1();
            context.Orders.Remove(context.Orders.Single(v => v.OrderID == key));
            context.SaveChanges();
            var data = context.Orders.ToList();
            return Json(data, JsonRequestBehavior.AllowGet);

        }
        public void ExportToExcel(string GridModel)
        {
            
            GridProperties gridPropert = ConvertGridObject(GridModel);
            ExcelExport exp = new ExcelExport();
            exp.Export(gridPropert, (IEnumerable)gridPropert.DataSource , "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-lime");

        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);

                //Check and retrieve additional property here
                if (ds.Key == "gridDataSource")
                {                    
                    string serialize = serializer.Serialize(ds.Value);
                    gridProp.DataSource = serializer.Deserialize<List<ExportData>>(serialize);
                    continue;
                }

                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        public class ExportData
        {
            public bool CheckBox { get; set; }
            public int OrderID { get; set; }
            public string CustomerID { get; set; }
            public Nullable<int> EmployeeID { get; set; }
            public Nullable<int> Freight { get; set; }
        }
    }
}
